net.sf.cpsolver.ifs.algorithms

## Class SimpleSearch<V extends Variable<V,T>,T extends Value<V,T>>

- java.lang.Object
- - net.sf.cpsolver.ifs.algorithms.SimpleSearch<V,T>

- All Implemented Interfaces:
    NeighbourSelection<V,T>, TerminationCondition<V,T>

      public class SimpleSearch<V extends Variable<V,T>,T extends Value<V,T>>
      extends Object
      implements NeighbourSelection<V,T>, TerminationCondition<V,T>

  Simple search neighbour selection.
  It consists of the following three phases:
  - Construction phase (`StandardNeighbourSelection` until all variables are assigned)
  - Hill-climbing phase (`HillClimber` until the given number if idle iterations)
  - Simulated annealing phase (`SimulatedAnnealing` until timeout is reached)
    - Or great deluge phase (when Search.GreatDeluge is true, `GreatDeluge` until timeout is reached)
  - At the end (when `TerminationCondition.canContinue(Solution)` is false), the search is finished with one sweep of final phase (`HillClimber` until the given number if idle iterations).
  Version:
    IFS 1.2 (Iterative Forward Search)
    Copyright (C) 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SimpleSearch(DataProperties properties)` Constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canContinue(Solution<V,T> currentSolution)` Termination condition (i.e., has final phase finished)
    `void` | `init(Solver<V,T> solver)` Initialization
    `boolean` | `isFinalPhase()` Is final phase
    `Neighbour<V,T>` | `selectNeighbour(Solution<V,T> solution)` Neighbour selection.
    `void` | `setFinalPhase(Callback finalPhaseFinished)` Set final phase

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SimpleSearch

          public SimpleSearch(DataProperties properties)
                       throws Exception

      Constructor
      Parameters:
        `properties` - problem properties
      Throws:
        `Exception`

  - ### Method Detail

    - #### init

          public void init(Solver<V,T> solver)

      Initialization
      Specified by:
        `init` in interface `NeighbourSelection<V extends Variable<V,T>,T extends Value<V,T>>`

    - #### selectNeighbour

          public Neighbour<V,T> selectNeighbour(Solution<V,T> solution)

      Neighbour selection. It consists of the following three phases:
      - Construction phase (`StandardNeighbourSelection` until all variables are assigned)
      - Hill-climbing phase (`HillClimber` until the given number if idle iterations)
      - Simulated annealing phase (`SimulatedAnnealing` until timeout is reached)
      Specified by:
        `selectNeighbour` in interface `NeighbourSelection<V extends Variable<V,T>,T extends Value<V,T>>`
      Parameters:
        `solution` - given solution
      Returns:
        a neighbour assignment

    - #### setFinalPhase

          public void setFinalPhase(Callback finalPhaseFinished)

      Set final phase
      Parameters:
        `finalPhaseFinished` - to be called when the final phase is finished

    - #### isFinalPhase

          public boolean isFinalPhase()

      Is final phase

    - #### canContinue

          public boolean canContinue(Solution<V,T> currentSolution)

      Termination condition (i.e., has final phase finished)
      Specified by:
        `canContinue` in interface `TerminationCondition<V extends Variable<V,T>,T extends Value<V,T>>`
      Parameters:
        `currentSolution` - current solution